diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/wifi/test/wifi-phy-ofdma-test.cc ns-3.40/src/wifi/test/wifi-phy-ofdma-test.cc
--- ns-3.39/src/wifi/test/wifi-phy-ofdma-test.cc	2023-07-05 14:23:48.129428400 -0700
+++ ns-3.40/src/wifi/test/wifi-phy-ofdma-test.cc	2023-09-27 13:30:37.926839800 -0700
@@ -2430,9 +2430,8 @@
                                       HePpdu::PSD_NON_HE_PORTION);
 
     // Send non-OFDMA part
-    Time nonOfdmaDuration = m_phy->GetHePhy()->CalculateNonOfdmaDurationForHeTb(txVector);
-    uint32_t centerFrequency =
-        m_phy->GetHePhy()->GetCenterFrequencyForNonOfdmaPart(txVector, staId);
+    Time nonOfdmaDuration = m_phy->GetHePhy()->CalculateNonHeDurationForHeTb(txVector);
+    uint32_t centerFrequency = m_phy->GetHePhy()->GetCenterFrequencyForNonHePart(txVector, staId);
     uint16_t ruWidth = HeRu::GetBandwidth(txVector.GetRu(staId).GetRuType());
     uint16_t channelWidth = ruWidth < 20 ? 20 : ruWidth;
     Ptr<SpectrumValue> rxPsd = WifiSpectrumValueHelper::CreateHeOfdmTxPowerSpectralDensity(
@@ -2445,7 +2444,6 @@
     rxParams->txPhy = nullptr;
     rxParams->duration = nonOfdmaDuration;
     rxParams->ppdu = ppdu;
-    rxParams->txWidth = channelWidth;
 
     uint16_t length;
     std::tie(length, ppduDuration) =
@@ -2472,7 +2470,6 @@
     rxParamsOfdma->txPhy = nullptr;
     rxParamsOfdma->duration = ppduDuration - nonOfdmaDuration;
     rxParamsOfdma->ppdu = ppduOfdma;
-    rxParamsOfdma->txWidth = DEFAULT_CHANNEL_WIDTH;
     Simulator::Schedule(nonOfdmaDuration,
                         &TestMultipleHeTbPreambles::RxHeTbPpduOfdmaPart,
                         this,
@@ -3982,8 +3979,8 @@
     WifiTxVector txVectorSta1 = GetTxVectorForHeTbPpdu(1, 1, 0);
     WifiTxVector txVectorSta2 = GetTxVectorForHeTbPpdu(2, 2, 0);
     Ptr<const HePhy> hePhy = m_phyAp->GetHePhy();
-    Time nonOfdmaDuration = hePhy->CalculateNonOfdmaDurationForHeTb(txVectorSta2);
-    NS_ASSERT(nonOfdmaDuration == hePhy->CalculateNonOfdmaDurationForHeTb(txVectorSta1));
+    Time nonOfdmaDuration = hePhy->CalculateNonHeDurationForHeTb(txVectorSta2);
+    NS_ASSERT(nonOfdmaDuration == hePhy->CalculateNonHeDurationForHeTb(txVectorSta1));
 
     std::vector<double> rxPowerNonOfdma{rxPowerNonOfdmaRu1, rxPowerNonOfdmaRu2};
     std::vector<WifiSpectrumBandInfo> nonOfdmaBand{hePhy->GetNonOfdmaBand(txVectorSta1, 1),
@@ -4891,7 +4888,7 @@
                                          DEFAULT_CHANNEL_WIDTH,
                                          false,
                                          false,
-                                         1);
+                                         true);
 
     HeRu::RuSpec ru(HeRu::RU_106_TONE, index, false);
     txVector.SetRu(ru, txStaId);
@@ -5187,7 +5184,7 @@
                             DEFAULT_CHANNEL_WIDTH,
                             false,
                             false,
-                            1);
+                            true);
     trigVector.SetRu(HeRu::RuSpec(HeRu::RU_106_TONE, 1, false), 1);
     trigVector.SetMode(HePhy::GetHeMcs7(), 1);
     trigVector.SetNss(1, 1);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/wifi/test/wifi-phy-reception-test.cc ns-3.40/src/wifi/test/wifi-phy-reception-test.cc
--- ns-3.39/src/wifi/test/wifi-phy-reception-test.cc	2023-07-05 14:23:48.133428300 -0700
+++ ns-3.40/src/wifi/test/wifi-phy-reception-test.cc	2023-09-27 13:30:37.926839800 -0700
@@ -145,7 +145,6 @@
     txParams->txPhy = nullptr;
     txParams->duration = txDuration;
     txParams->ppdu = ppdu;
-    txParams->txWidth = CHANNEL_WIDTH;
 
     m_phy->StartRx(txParams, nullptr);
 }
@@ -2805,7 +2804,6 @@
     txParams->txPhy = nullptr;
     txParams->duration = txDuration;
     txParams->ppdu = ppdu;
-    txParams->txWidth = CHANNEL_WIDTH;
 
     m_phy->StartRx(txParams, nullptr);
 }
@@ -4328,7 +4326,6 @@
     txParams->txPhy = nullptr;
     txParams->duration = txDuration;
     txParams->ppdu = ppdu;
-    txParams->txWidth = bandwidthMhz;
 
     m_rxPhy->StartRx(txParams, nullptr);
 }
@@ -4619,12 +4616,8 @@
                           "PPDU is " << (expectedP20Overlap ? "expected" : "not expected")
                                      << " to overlap with the P20");
 
-    auto p20Covered =
-        m_rxPhy->GetPhyEntity(WIFI_STANDARD_80211ax)
-            ->CanStartRx(
-                ppdu,
-                ppdu->GetTxVector()
-                    .GetChannelWidth()); // CanStartRx returns true is the P20 is fully covered
+    auto p20Covered = m_rxPhy->GetPhyEntity(WIFI_STANDARD_80211ax)
+                          ->CanStartRx(ppdu); // CanStartRx returns true is the P20 is fully covered
     NS_TEST_ASSERT_MSG_EQ(p20Covered,
                           expectedP20Covered,
                           "PPDU is " << (expectedP20Covered ? "expected" : "not expected")
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/wifi/test/wifi-phy-thresholds-test.cc ns-3.40/src/wifi/test/wifi-phy-thresholds-test.cc
--- ns-3.39/src/wifi/test/wifi-phy-thresholds-test.cc	2023-07-05 14:23:48.133428300 -0700
+++ ns-3.40/src/wifi/test/wifi-phy-thresholds-test.cc	2023-09-27 13:30:37.926839800 -0700
@@ -179,7 +179,6 @@
     txParams->txPhy = nullptr;
     txParams->duration = txDuration;
     txParams->ppdu = ppdu;
-    txParams->txWidth = CHANNEL_WIDTH;
     return txParams;
 }
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/wifi/test/wifi-primary-channels-test.cc ns-3.40/src/wifi/test/wifi-primary-channels-test.cc
--- ns-3.39/src/wifi/test/wifi-primary-channels-test.cc	2023-07-05 14:23:48.133428300 -0700
+++ ns-3.40/src/wifi/test/wifi-primary-channels-test.cc	2023-09-27 13:30:37.926839800 -0700
@@ -665,7 +665,7 @@
         {
             for (unsigned int type = 0; type < 7; type++)
             {
-                HeRu::RuType ruType = static_cast<HeRu::RuType>(type);
+                auto ruType = static_cast<HeRu::RuType>(type);
                 std::size_t nRus = HeRu::GetNRus(txChannelWidth, ruType);
                 std::set<uint8_t> txBss;
                 if (nRus > 0)
@@ -713,7 +713,7 @@
         {
             for (unsigned int type = 0; type < 7; type++)
             {
-                HeRu::RuType ruType = static_cast<HeRu::RuType>(type);
+                auto ruType = static_cast<HeRu::RuType>(type);
                 std::size_t nRus = HeRu::GetNRus(txChannelWidth, ruType);
                 std::set<uint8_t> txBss;
                 if (nRus > 0)
@@ -1375,10 +1375,13 @@
     // Test cases for 20 MHz can be added, but are not that useful (there would be a single BSS)
     AddTestCase(new WifiPrimaryChannelsTest(40, true), TestCase::QUICK);
     AddTestCase(new WifiPrimaryChannelsTest(40, false), TestCase::QUICK);
+#if 0
+    // Tests disabled until issue #776 resolved
     AddTestCase(new WifiPrimaryChannelsTest(80, true), TestCase::EXTENSIVE);
     AddTestCase(new WifiPrimaryChannelsTest(80, false), TestCase::EXTENSIVE);
     AddTestCase(new WifiPrimaryChannelsTest(160, true), TestCase::TAKES_FOREVER);
     AddTestCase(new WifiPrimaryChannelsTest(160, false), TestCase::TAKES_FOREVER);
+#endif
     AddTestCase(new Wifi20MHzChannelIndicesTest(), TestCase::QUICK);
 }
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/wifi/test/wifi-test.cc ns-3.40/src/wifi/test/wifi-test.cc
--- ns-3.39/src/wifi/test/wifi-test.cc	2023-07-05 14:23:48.133428300 -0700
+++ ns-3.40/src/wifi/test/wifi-test.cc	2023-09-27 13:30:37.926839800 -0700
@@ -1185,7 +1185,6 @@
         staDevice = wifi.Install(phy, macSta, wifiStaNode.Get(0));
         phySta = GetYansWifiPhyPtr(staDevice);
         phySta->SetAttribute("ChannelSettings", StringValue("{3, 20, BAND_2_4GHZ, 0}"));
-        return;
         // Post-install reconfiguration to a 40 MHz channel
         std::ostringstream path;
         path << "/NodeList/*/DeviceList/" << staDevice.Get(0)->GetIfIndex()
@@ -1579,9 +1578,7 @@
     FreqWidthSubbandModulationTuple tupleForCurrentTx =
         std::make_tuple(startingFreq, m_channelWidth, numBands, modulationClass);
     bool found = false;
-    for (std::vector<FreqWidthSubbandModulationTuple>::const_iterator it = m_distinctTuples.begin();
-         it != m_distinctTuples.end();
-         it++)
+    for (auto it = m_distinctTuples.begin(); it != m_distinctTuples.end(); it++)
     {
         if (*it == tupleForCurrentTx)
         {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/wifi/test/wifi-transmit-mask-test.cc ns-3.40/src/wifi/test/wifi-transmit-mask-test.cc
--- ns-3.39/src/wifi/test/wifi-transmit-mask-test.cc	2023-07-05 14:23:48.133428300 -0700
+++ ns-3.40/src/wifi/test/wifi-transmit-mask-test.cc	2023-09-27 13:30:37.926839800 -0700
@@ -994,7 +994,7 @@
                                                maskSlopes,
                                                tol,
                                                prec,
-                                               {1, 0, 0, 0}),
+                                               {true, false, false, false}),
                 TestCase::QUICK);
 
     // ============================================================================================
@@ -1038,7 +1038,7 @@
                                                maskSlopes,
                                                tol,
                                                prec,
-                                               {0, 1, 0, 0}),
+                                               {false, true, false, false}),
                 TestCase::QUICK);
 
     // ============================================================================================
@@ -1082,7 +1082,7 @@
                                                maskSlopes,
                                                tol,
                                                prec,
-                                               {0, 0, 1, 0}),
+                                               {false, false, true, false}),
                 TestCase::QUICK);
 
     // ============================================================================================
@@ -1122,7 +1122,7 @@
                                                maskSlopes,
                                                tol,
                                                prec,
-                                               {0, 0, 0, 1}),
+                                               {false, false, false, true}),
                 TestCase::QUICK);
 
     // ============================================================================================
@@ -1162,15 +1162,16 @@
         std::make_pair(6144, -40.0),    // Outer band right (stop)
     };
 
-    AddTestCase(new WifiOfdmMaskSlopesTestCase("11ax_5GHz 160MHz first subchannels punctured",
-                                               WIFI_STANDARD_80211ax,
-                                               WIFI_PHY_BAND_5GHZ,
-                                               160,
-                                               maskSlopes,
-                                               tol,
-                                               prec,
-                                               {1, 1, 0, 0, 0, 0, 0, 0}),
-                TestCase::QUICK);
+    AddTestCase(
+        new WifiOfdmMaskSlopesTestCase("11ax_5GHz 160MHz first subchannels punctured",
+                                       WIFI_STANDARD_80211ax,
+                                       WIFI_PHY_BAND_5GHZ,
+                                       160,
+                                       maskSlopes,
+                                       tol,
+                                       prec,
+                                       {true, true, false, false, false, false, false, false}),
+        TestCase::QUICK);
 
     // ============================================================================================
     // 11ax 160MHz @ 5GHz - third and fourth 20 MHz subchannels punctured
@@ -1219,7 +1220,7 @@
                                        maskSlopes,
                                        tol,
                                        prec,
-                                       {0, 0, 1, 1, 0, 0, 0, 0}),
+                                       {false, false, true, true, false, false, false, false}),
         TestCase::QUICK);
 
     // ============================================================================================
@@ -1269,7 +1270,7 @@
                                        maskSlopes,
                                        tol,
                                        prec,
-                                       {0, 0, 0, 0, 1, 1, 0, 0}),
+                                       {false, false, false, false, true, true, false, false}),
         TestCase::QUICK);
 
     // ============================================================================================
@@ -1309,13 +1310,14 @@
         std::make_pair(6144, -40.0),   // Outer band right (stop)
     };
 
-    AddTestCase(new WifiOfdmMaskSlopesTestCase("11ax_5GHz 160MHz last subchannels punctured",
-                                               WIFI_STANDARD_80211ax,
-                                               WIFI_PHY_BAND_5GHZ,
-                                               160,
-                                               maskSlopes,
-                                               tol,
-                                               prec,
-                                               {0, 0, 0, 0, 0, 0, 1, 1}),
-                TestCase::QUICK);
+    AddTestCase(
+        new WifiOfdmMaskSlopesTestCase("11ax_5GHz 160MHz last subchannels punctured",
+                                       WIFI_STANDARD_80211ax,
+                                       WIFI_PHY_BAND_5GHZ,
+                                       160,
+                                       maskSlopes,
+                                       tol,
+                                       prec,
+                                       {false, false, false, false, false, false, true, true}),
+        TestCase::QUICK);
 }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/wimax/examples/wimax-ipv4.cc ns-3.40/src/wimax/examples/wimax-ipv4.cc
--- ns-3.39/src/wimax/examples/wimax-ipv4.cc	2023-07-05 14:23:48.133428300 -0700
+++ ns-3.40/src/wimax/examples/wimax-ipv4.cc	2023-09-27 13:30:37.926839800 -0700
@@ -117,7 +117,7 @@
                            WimaxHelper::SIMPLE_PHY_TYPE_OFDM,
                            scheduler);
 
-    Ptr<SubscriberStationNetDevice>* ss = new Ptr<SubscriberStationNetDevice>[nbSS];
+    auto ss = new Ptr<SubscriberStationNetDevice>[nbSS];
 
     for (int i = 0; i < nbSS; i++)
     {
@@ -146,10 +146,10 @@
         WimaxHelper::EnableLogComponents(); // Turn on all wimax logging
     }
     /*------------------------------*/
-    UdpServerHelper* udpServer = new UdpServerHelper[nbSS / 2];
-    ApplicationContainer* serverApps = new ApplicationContainer[nbSS / 2];
-    UdpClientHelper* udpClient = new UdpClientHelper[nbSS / 2];
-    ApplicationContainer* clientApps = new ApplicationContainer[nbSS / 2];
+    auto udpServer = new UdpServerHelper[nbSS / 2];
+    auto serverApps = new ApplicationContainer[nbSS / 2];
+    auto udpClient = new UdpClientHelper[nbSS / 2];
+    auto clientApps = new ApplicationContainer[nbSS / 2];
 
     for (int i = 0; i < nbSS / 2; i++)
     {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/wimax/helper/wimax-helper.cc ns-3.40/src/wimax/helper/wimax-helper.cc
--- ns-3.39/src/wimax/helper/wimax-helper.cc	2023-07-05 14:23:48.133428300 -0700
+++ ns-3.40/src/wimax/helper/wimax-helper.cc	2023-09-27 13:30:37.926839800 -0700
@@ -224,7 +224,7 @@
                      double frameDuration)
 {
     NetDeviceContainer devices;
-    for (NodeContainer::Iterator i = c.Begin(); i != c.End(); i++)
+    for (auto i = c.Begin(); i != c.End(); i++)
     {
         Ptr<Node> node = *i;
         Ptr<WimaxPhy> phy = CreatePhy(phyType);
@@ -268,7 +268,7 @@
                      SchedulerType schedulerType)
 {
     NetDeviceContainer devices;
-    for (NodeContainer::Iterator i = c.Begin(); i != c.End(); i++)
+    for (auto i = c.Begin(); i != c.End(); i++)
     {
         Ptr<Node> node = *i;
         Ptr<WimaxPhy> phy = CreatePhy(phyType);
@@ -309,11 +309,11 @@
                      SchedulerType schedulerType)
 {
     NetDeviceContainer devices;
-    for (NodeContainer::Iterator i = c.Begin(); i != c.End(); i++)
+    for (auto i = c.Begin(); i != c.End(); i++)
     {
         Ptr<Node> node = *i;
 
-        Ptr<WimaxPhy> phy = CreatePhyWithoutChannel(phyType, (char*)"dummy", 0);
+        Ptr<WimaxPhy> phy = CreatePhyWithoutChannel(phyType, (char*)"dummy", false);
         Ptr<WimaxNetDevice> device;
         Ptr<UplinkScheduler> uplinkScheduler = CreateUplinkScheduler(schedulerType);
         Ptr<BSScheduler> bsScheduler = CreateBSScheduler(schedulerType);
@@ -349,7 +349,7 @@
                      SchedulerType schedulerType)
 {
     // Ptr<WimaxPhy> phy = CreatePhyWithoutChannel (phyType);
-    Ptr<WimaxPhy> phy = CreatePhyWithoutChannel(phyType, (char*)"dummy", 0);
+    Ptr<WimaxPhy> phy = CreatePhyWithoutChannel(phyType, (char*)"dummy", false);
     Ptr<WimaxNetDevice> device;
     Ptr<UplinkScheduler> uplinkScheduler = CreateUplinkScheduler(schedulerType);
     Ptr<BSScheduler> bsScheduler = CreateBSScheduler(schedulerType);
@@ -637,7 +637,7 @@
 PcapSniffTxRxEvent(Ptr<PcapFileWrapper> file, Ptr<const PacketBurst> burst)
 {
     std::list<Ptr<Packet>> packets = burst->GetPackets();
-    for (std::list<Ptr<Packet>>::iterator iter = packets.begin(); iter != packets.end(); ++iter)
+    for (auto iter = packets.begin(); iter != packets.end(); ++iter)
     {
         Ptr<Packet> p = (*iter)->Copy();
         WimaxMacToMacHeader m2m(p->GetSize());
@@ -696,7 +696,7 @@
 {
     int64_t currentStream = stream;
     Ptr<NetDevice> netDevice;
-    for (NetDeviceContainer::Iterator i = c.Begin(); i != c.End(); ++i)
+    for (auto i = c.Begin(); i != c.End(); ++i)
     {
         netDevice = (*i);
         Ptr<WimaxNetDevice> wimax = DynamicCast<WimaxNetDevice>(netDevice);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/wimax/model/bandwidth-manager.cc ns-3.40/src/wimax/model/bandwidth-manager.cc
--- ns-3.39/src/wimax/model/bandwidth-manager.cc	2023-07-05 14:23:48.133428300 -0700
+++ ns-3.40/src/wimax/model/bandwidth-manager.cc	2023-09-27 13:30:37.926839800 -0700
@@ -129,9 +129,7 @@
     std::vector<ServiceFlow*> serviceFlows =
         ss->GetServiceFlowManager()->GetServiceFlows(ServiceFlow::SF_TYPE_ALL);
 
-    for (std::vector<ServiceFlow*>::iterator iter = serviceFlows.begin();
-         iter != serviceFlows.end();
-         ++iter)
+    for (auto iter = serviceFlows.begin(); iter != serviceFlows.end(); ++iter)
     {
         serviceFlow = *iter;
         if (serviceFlow->GetSchedulingType() == ServiceFlow::SF_TYPE_RTPS ||
@@ -229,15 +227,11 @@
     uint32_t allocationPerFrame = 0;
 
     std::vector<SSRecord*>* ssRecords = bs->GetSSManager()->GetSSRecords();
-    for (std::vector<SSRecord*>::const_iterator iter1 = ssRecords->begin();
-         iter1 != ssRecords->end();
-         ++iter1)
+    for (auto iter1 = ssRecords->begin(); iter1 != ssRecords->end(); ++iter1)
     {
         std::vector<ServiceFlow*> ssServiceFlows =
             (*iter1)->GetServiceFlows(ServiceFlow::SF_TYPE_ALL);
-        for (std::vector<ServiceFlow*>::const_iterator iter2 = ssServiceFlows.begin();
-             iter2 != ssServiceFlows.end();
-             ++iter2)
+        for (auto iter2 = ssServiceFlows.begin(); iter2 != ssServiceFlows.end(); ++iter2)
         {
             allocationPerFrame += (*iter2)->GetRecord()->GetGrantSize();
         }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/wimax/model/bs-link-manager.cc ns-3.40/src/wimax/model/bs-link-manager.cc
--- ns-3.39/src/wimax/model/bs-link-manager.cc	2023-07-05 14:23:48.133428300 -0700
+++ ns-3.40/src/wimax/model/bs-link-manager.cc	2023-09-27 13:30:37.926839800 -0700
@@ -257,7 +257,7 @@
 
             if (ssRecord->GetInvitedRangRetries() == m_bs->GetMaxInvitedRangRetries())
             {
-                RngRsp* rngrsp = new RngRsp();
+                auto rngrsp = new RngRsp();
                 AbortRanging(ssRecord->GetBasicCid(), rngrsp, ssRecord, true);
             } // else keep polling
         }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/wimax/model/bs-net-device.cc ns-3.40/src/wimax/model/bs-net-device.cc
--- ns-3.39/src/wimax/model/bs-net-device.cc	2023-07-05 14:23:48.133428300 -0700
+++ ns-3.40/src/wimax/model/bs-net-device.cc	2023-09-27 13:30:37.926839800 -0700
@@ -851,9 +851,7 @@
 
                     // DEFRAGMENTATION
                     NS_LOG_INFO("\t BS PACKET DEFRAGMENTATION" << std::endl);
-                    for (std::list<Ptr<const Packet>>::const_iterator iter = fragmentsQueue.begin();
-                         iter != fragmentsQueue.end();
-                         ++iter)
+                    for (auto iter = fragmentsQueue.begin(); iter != fragmentsQueue.end(); ++iter)
                     {
                         // Create the whole Packet
                         fullPacket->AddAtEnd(*iter);
@@ -1029,10 +1027,7 @@
     std::list<std::pair<OfdmDlMapIe*, Ptr<PacketBurst>>>* downlinkBursts =
         m_scheduler->GetDownlinkBursts();
 
-    for (std::list<std::pair<OfdmDlMapIe*, Ptr<PacketBurst>>>::iterator iter =
-             downlinkBursts->begin();
-         iter != downlinkBursts->end();
-         ++iter)
+    for (auto iter = downlinkBursts->begin(); iter != downlinkBursts->end(); ++iter)
     {
         iter->first->SetPreamblePresent(0);
         iter->first->SetStartTime(0);
@@ -1096,9 +1091,7 @@
 
     std::list<OfdmUlMapIe> uplinkAllocations = m_uplinkScheduler->GetUplinkAllocations();
 
-    for (std::list<OfdmUlMapIe>::iterator iter = uplinkAllocations.begin();
-         iter != uplinkAllocations.end();
-         ++iter)
+    for (auto iter = uplinkAllocations.begin(); iter != uplinkAllocations.end(); ++iter)
     {
         ulmap.AddUlMapElement(*iter);
     }
@@ -1197,9 +1190,7 @@
 {
     uint16_t symbolsToAllocation = 0;
     std::list<OfdmUlMapIe> uplinkAllocations = m_uplinkScheduler->GetUplinkAllocations();
-    for (std::list<OfdmUlMapIe>::iterator iter = uplinkAllocations.begin();
-         iter != uplinkAllocations.end();
-         ++iter)
+    for (auto iter = uplinkAllocations.begin(); iter != uplinkAllocations.end(); ++iter)
     {
         OfdmUlMapIe uplinkAllocation = *iter;
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/wimax/model/bs-net-device.h ns-3.40/src/wimax/model/bs-net-device.h
--- ns-3.39/src/wimax/model/bs-net-device.h	2023-07-05 14:23:48.133428300 -0700
+++ ns-3.40/src/wimax/model/bs-net-device.h	2023-09-27 13:30:37.926839800 -0700
@@ -21,12 +21,12 @@
 #ifndef WIMAX_BS_NET_DEVICE_H
 #define WIMAX_BS_NET_DEVICE_H
 
+#include "bs-service-flow-manager.h"
 #include "dl-mac-messages.h"
 #include "ipcs-classifier.h"
 #include "wimax-connection.h"
 #include "wimax-net-device.h"
 
-#include "ns3/bs-service-flow-manager.h"
 #include "ns3/event-id.h"
 #include "ns3/ipv4-address.h"
 #include "ns3/mac48-address.h"
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/wimax/model/bs-scheduler-rtps.cc ns-3.40/src/wimax/model/bs-scheduler-rtps.cc
--- ns-3.39/src/wimax/model/bs-scheduler-rtps.cc	2023-07-05 14:23:48.133428300 -0700
+++ ns-3.40/src/wimax/model/bs-scheduler-rtps.cc	2023-09-27 13:30:37.926839800 -0700
@@ -96,7 +96,7 @@
                                   WimaxPhy::ModulationType modulationType,
                                   Ptr<PacketBurst> burst)
 {
-    OfdmDlMapIe* dlMapIe = new OfdmDlMapIe();
+    auto dlMapIe = new OfdmDlMapIe();
     dlMapIe->SetCid(connection->GetCid());
     dlMapIe->SetDiuc(diuc);
 
@@ -319,11 +319,10 @@
     Ptr<Packet> packet;
     Ptr<PacketBurst> burst = Create<PacketBurst>();
 
-    std::vector<Ptr<WimaxConnection>>::const_iterator iter;
     std::vector<Ptr<WimaxConnection>> connections;
 
     connections = GetBs()->GetConnectionManager()->GetConnections(Cid::BASIC);
-    for (iter = connections.begin(); iter != connections.end(); ++iter)
+    for (auto iter = connections.begin(); iter != connections.end(); ++iter)
     {
         while ((*iter)->HasPackets() && availableSymbols > 0)
         {
@@ -381,11 +380,10 @@
     Ptr<Packet> packet;
     Ptr<PacketBurst> burst = Create<PacketBurst>();
 
-    std::vector<Ptr<WimaxConnection>>::const_iterator iter;
     std::vector<Ptr<WimaxConnection>> connections;
 
     connections = GetBs()->GetConnectionManager()->GetConnections(Cid::PRIMARY);
-    for (iter = connections.begin(); iter != connections.end(); ++iter)
+    for (auto iter = connections.begin(); iter != connections.end(); ++iter)
     {
         while ((*iter)->HasPackets() && availableSymbols > 0)
         {
@@ -444,12 +442,11 @@
 
     Time currentTime = Simulator::Now();
 
-    std::vector<ServiceFlow*>::iterator iter;
     ServiceFlowRecord* serviceFlowRecord;
     std::vector<ServiceFlow*> serviceFlows;
 
     serviceFlows = GetBs()->GetServiceFlowManager()->GetServiceFlows(ServiceFlow::SF_TYPE_UGS);
-    for (iter = serviceFlows.begin(); iter != serviceFlows.end(); ++iter)
+    for (auto iter = serviceFlows.begin(); iter != serviceFlows.end(); ++iter)
     {
         serviceFlowRecord = (*iter)->GetRecord();
         // if latency would exceed in case grant is allocated in next frame then allocate in current
@@ -503,7 +500,6 @@
     Time currentTime = Simulator::Now();
 
     std::vector<Ptr<WimaxConnection>> connections;
-    std::vector<ServiceFlow*>::iterator iter2;
     ServiceFlowRecord* serviceFlowRecord;
     std::vector<ServiceFlow*> serviceFlows;
 
@@ -520,7 +516,7 @@
 
     serviceFlows = GetBs()->GetServiceFlowManager()->GetServiceFlows(ServiceFlow::SF_TYPE_RTPS);
     nbConnection = 0;
-    for (iter2 = serviceFlows.begin(); iter2 != serviceFlows.end(); ++iter2)
+    for (auto iter2 = serviceFlows.begin(); iter2 != serviceFlows.end(); ++iter2)
     {
         // DL RTPS Scheduler works for all rtPS connection that have packets to transmitt!!!
         serviceFlowRecord = (*iter2)->GetRecord();
@@ -644,11 +640,10 @@
     Ptr<Packet> packet;
     Ptr<PacketBurst> burst = Create<PacketBurst>();
 
-    std::vector<ServiceFlow*>::iterator iter;
     std::vector<ServiceFlow*> serviceFlows;
 
     serviceFlows = GetBs()->GetServiceFlowManager()->GetServiceFlows(ServiceFlow::SF_TYPE_NRTPS);
-    for (iter = serviceFlows.begin(); iter != serviceFlows.end(); ++iter)
+    for (auto iter = serviceFlows.begin(); iter != serviceFlows.end(); ++iter)
     {
         connection = (*iter)->GetConnection();
 
@@ -702,11 +697,10 @@
     Ptr<Packet> packet;
     Ptr<PacketBurst> burst = Create<PacketBurst>();
 
-    std::vector<ServiceFlow*>::iterator iter;
     std::vector<ServiceFlow*> serviceFlows;
 
     serviceFlows = GetBs()->GetServiceFlowManager()->GetServiceFlows(ServiceFlow::SF_TYPE_BE);
-    for (iter = serviceFlows.begin(); iter != serviceFlows.end(); ++iter)
+    for (auto iter = serviceFlows.begin(); iter != serviceFlows.end(); ++iter)
     {
         connection = (*iter)->GetConnection();
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/wimax/model/bs-scheduler-simple.cc ns-3.40/src/wimax/model/bs-scheduler-simple.cc
--- ns-3.39/src/wimax/model/bs-scheduler-simple.cc	2023-07-05 14:23:48.133428300 -0700
+++ ns-3.40/src/wimax/model/bs-scheduler-simple.cc	2023-09-27 13:30:37.926839800 -0700
@@ -94,7 +94,7 @@
                                     WimaxPhy::ModulationType modulationType,
                                     Ptr<PacketBurst> burst)
 {
-    OfdmDlMapIe* dlMapIe = new OfdmDlMapIe();
+    auto dlMapIe = new OfdmDlMapIe();
     dlMapIe->SetCid(connection->GetCid());
     dlMapIe->SetDiuc(diuc);
 
@@ -243,8 +243,6 @@
 {
     connection = nullptr;
     Time currentTime = Simulator::Now();
-    std::vector<Ptr<WimaxConnection>>::const_iterator iter1;
-    std::vector<ServiceFlow*>::iterator iter2;
     ServiceFlowRecord* serviceFlowRecord;
     NS_LOG_INFO("BS Scheduler: Selecting connection...");
     if (GetBs()->GetBroadcastConnection()->HasPackets())
@@ -265,7 +263,7 @@
         std::vector<ServiceFlow*> serviceFlows;
 
         connections = GetBs()->GetConnectionManager()->GetConnections(Cid::BASIC);
-        for (iter1 = connections.begin(); iter1 != connections.end(); ++iter1)
+        for (auto iter1 = connections.begin(); iter1 != connections.end(); ++iter1)
         {
             if ((*iter1)->HasPackets())
             {
@@ -276,7 +274,7 @@
         }
 
         connections = GetBs()->GetConnectionManager()->GetConnections(Cid::PRIMARY);
-        for (iter1 = connections.begin(); iter1 != connections.end(); ++iter1)
+        for (auto iter1 = connections.begin(); iter1 != connections.end(); ++iter1)
         {
             if ((*iter1)->HasPackets())
             {
@@ -287,7 +285,7 @@
         }
 
         serviceFlows = GetBs()->GetServiceFlowManager()->GetServiceFlows(ServiceFlow::SF_TYPE_UGS);
-        for (iter2 = serviceFlows.begin(); iter2 != serviceFlows.end(); ++iter2)
+        for (auto iter2 = serviceFlows.begin(); iter2 != serviceFlows.end(); ++iter2)
         {
             serviceFlowRecord = (*iter2)->GetRecord();
             NS_LOG_INFO("processing UGS: HAS PACKET="
@@ -310,7 +308,7 @@
         }
 
         serviceFlows = GetBs()->GetServiceFlowManager()->GetServiceFlows(ServiceFlow::SF_TYPE_RTPS);
-        for (iter2 = serviceFlows.begin(); iter2 != serviceFlows.end(); ++iter2)
+        for (auto iter2 = serviceFlows.begin(); iter2 != serviceFlows.end(); ++iter2)
         {
             serviceFlowRecord = (*iter2)->GetRecord();
             // if latency would exceed in case poll is allocated in next frame then allocate in
@@ -329,7 +327,7 @@
 
         serviceFlows =
             GetBs()->GetServiceFlowManager()->GetServiceFlows(ServiceFlow::SF_TYPE_NRTPS);
-        for (iter2 = serviceFlows.begin(); iter2 != serviceFlows.end(); ++iter2)
+        for (auto iter2 = serviceFlows.begin(); iter2 != serviceFlows.end(); ++iter2)
         {
             // unused: serviceFlowRecord = (*iter2)->GetRecord ();
             if ((*iter2)->HasPackets())
@@ -342,7 +340,7 @@
         }
 
         serviceFlows = GetBs()->GetServiceFlowManager()->GetServiceFlows(ServiceFlow::SF_TYPE_BE);
-        for (iter2 = serviceFlows.begin(); iter2 != serviceFlows.end(); ++iter2)
+        for (auto iter2 = serviceFlows.begin(); iter2 != serviceFlows.end(); ++iter2)
         {
             // unused: serviceFlowRecord = (*iter2)->GetRecord ();
             if ((*iter2)->HasPackets())
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/wimax/model/bs-service-flow-manager.cc ns-3.40/src/wimax/model/bs-service-flow-manager.cc
--- ns-3.39/src/wimax/model/bs-service-flow-manager.cc	2023-07-05 14:23:48.133428300 -0700
+++ ns-3.40/src/wimax/model/bs-service-flow-manager.cc	2023-09-27 13:30:37.926839800 -0700
@@ -223,7 +223,7 @@
 void
 BsServiceFlowManager::AddMulticastServiceFlow(ServiceFlow sf, WimaxPhy::ModulationType modulation)
 {
-    ServiceFlow* serviceFlow = new ServiceFlow();
+    auto serviceFlow = new ServiceFlow();
     serviceFlow->CopyParametersFrom(sf);
     Ptr<BaseStationNetDevice> bs = m_device->GetObject<BaseStationNetDevice>();
     Ptr<WimaxConnection> multicastConnection =
